Lattice Grid Buy a licence

demo D119

Excel export

A styled .xlsx with frozen panes, written with no dependency

export.excel()

Building…
Loading a live grid…

The configuration

<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.min.css">

<div id="grid"></div>

<script type="module">
  import React from 'https://esm.sh/react@18';
  import { createRoot } from 'https://esm.sh/react-dom@18/client';
  import { createGrid } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.esm.min.js';
  import createLatticeGrid from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/modules/react.esm.min.js';

  const LatticeGrid = createLatticeGrid({ React, createGrid });

  const columns = [
    { field: 'ref', title: 'Invoice', layout: { pin: 'start', width: 140 } },
    { field: 'supplier', title: 'Supplier', layout: { flex: 1, min: 200 }, filter: { type: 'set' } },
    { field: 'region', title: 'Region', filter: { type: 'set' } },
    { field: 'category', title: 'Category', filter: { type: 'set' } },
    { field: 'quantity', title: 'Qty', type: 'number', layout: { width: 110 } },
    { field: 'amount', title: 'Amount', type: 'number', layout: { width: 150 },
      format: { style: 'currency', currency: 'GBP', decimals: 2 }, total: 'sum', filter: { type: 'number' } },
    { field: 'note', title: 'Note', layout: { width: 280 } },
  ];

  // The workbook is written in the browser with no dependency: a zip container,
  // the sheet, the shared strings and the styles, assembled by the grid. Nothing
  // is uploaded and nothing is fetched. The rail's Excel button takes the
  // defaults; the named one sets the options and writes a real frozen header.
  const toolPanel = {
    side: 'left',
    panels: ['columns', 'filters', 'quick'],
    exportName: 'supplier-charges',
    actions: [
      'undo', 'redo', 'restore', 'maximise', '-',
      'excel',
      {
        name: 'excel-named',
        title: 'Download .xlsx, named sheet with a frozen header',
        icon: 'spreadsheet',
        run: ({ grid }) => grid.export.excel({
          download: true,
          fileName: 'supplier-charges-q3',
          sheetName: 'Charges',
          freezePanes: true,
          variantFills: true,
        }),
      },
      'clipboard',
    ],
  };

  const rows = [/* supplier charge records, one per invoice line */];

  function App() {
    const gridRef = React.useRef(null);

    // The same writer, reached imperatively through the ref: a named sheet with a
    // frozen header, saved from your own button or effect.
    const download = () => gridRef.current.grid.export.excel({
      download: true,
      fileName: 'supplier-charges-q3',
      sheetName: 'Charges',
      freezePanes: true,
      variantFills: true,
    });

    return (
      <>
        <button onClick={download}>Download .xlsx</button>
        <LatticeGrid
          ref={gridRef}
          rowKey="id"
          selection="multiple"
          toolPanel={toolPanel}
          columns={columns}
          rows={rows}
          style={{ height: '540px', marginTop: '8px' }}
        />
      </>
    );
  }

  createRoot(document.getElementById('grid')).render(<App />);
</script>

Generating a styled .xlsx workbook straight from the grid

Excel export writes the current grid state to a real .xlsx workbook, not a renamed CSV, so column widths, header styling and frozen panes survive the round trip into Excel or Google Sheets. A developer reaches for it wherever a report needs to leave the browser as a file a finance or operations colleague can open, filter and pivot on their own machine, rather than a static screenshot or a print-to-PDF. Calling export.excel() on a Lattice Grid instance builds the workbook from whatever is currently visible: the active column order, current sort, and any grouping, so the file a user downloads matches what they were looking at, not a fixed server-side template. As a JavaScript data grid with no server round trip involved, the export runs entirely client-side with no dependency pulled in to construct the workbook, which keeps the download instant even on a dataset of several thousand rows and avoids sending grid data to a backend purely to format a spreadsheet. Frozen panes are carried across automatically wherever the grid itself has pinned columns or a pinned header row, so the exported sheet keeps row and column headers in view exactly as the on-screen grid does, without a separate freeze-pane step for the developer to configure by hand.

How do I export a data grid to a formatted Excel file?

Call export.excel() on the grid instance. Lattice Grid writes an .xlsx file reflecting the current column order, sort and grouping, with header styling and any pinned rows or columns carried over as frozen panes, so the downloaded workbook opens in Excel already formatted rather than as a plain data dump needing manual cleanup.

Lattice Grid Buy a licence

demo D119

Excel export

A styled .xlsx with frozen panes, written with no dependency

export.excel()

Building…
Loading a live grid…

The configuration

import * as ng from '@angular/core';
import { Component, ViewChild } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { createGrid } from '@toclocoinc/lattice-grid';
import '@toclocoinc/lattice-grid/css';
import createLatticeGrid from '@toclocoinc/lattice-grid/modules/angular';

const { LatticeGridComponent } = createLatticeGrid({ ng, createGrid });

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [LatticeGridComponent],
  template:
    '<button (click)="download()">Download .xlsx</button>' +
    '<lattice-grid [config]="grid" style="display:block;height:540px;margin-top:8px"></lattice-grid>',
})
export class AppComponent {
  @ViewChild(LatticeGridComponent) gridRef!: LatticeGridComponent;

  // The workbook is written in the browser with no dependency: a zip container,
  // the sheet, the shared strings and the styles, assembled by the grid. The
  // rail's Excel button takes the defaults; the named one sets the options.
  grid = {
    rowKey: 'id',
    selection: 'multiple',
    toolPanel: {
      side: 'left',
      panels: ['columns', 'filters', 'quick'],
      exportName: 'supplier-charges',
      actions: [
        'undo', 'redo', 'restore', 'maximise', '-',
        'excel',
        {
          name: 'excel-named',
          title: 'Download .xlsx, named sheet with a frozen header',
          icon: 'spreadsheet',
          run: ({ grid }: any) => grid.export.excel({
            download: true, fileName: 'supplier-charges-q3', sheetName: 'Charges',
            freezePanes: true, variantFills: true,
          }),
        },
        'clipboard',
      ],
    },
    columns: [
      { field: 'ref', title: 'Invoice', layout: { pin: 'start', width: 140 } },
      { field: 'supplier', title: 'Supplier', layout: { flex: 1, min: 200 }, filter: { type: 'set' } },
      { field: 'region', title: 'Region', filter: { type: 'set' } },
      { field: 'category', title: 'Category', filter: { type: 'set' } },
      { field: 'quantity', title: 'Qty', type: 'number', layout: { width: 110 } },
      { field: 'amount', title: 'Amount', type: 'number', layout: { width: 150 },
        format: { style: 'currency', currency: 'GBP', decimals: 2 }, total: 'sum', filter: { type: 'number' } },
      { field: 'note', title: 'Note', layout: { width: 280 } },
    ],
    rows: [/* supplier charge records, one per invoice line */],
  };

  // The same writer, reached through the component: a named sheet with a frozen
  // header, saved from your own button.
  download() {
    this.gridRef.grid.export.excel({
      download: true, fileName: 'supplier-charges-q3', sheetName: 'Charges',
      freezePanes: true, variantFills: true,
    });
  }
}

bootstrapApplication(AppComponent);

Generating a styled .xlsx workbook straight from the grid

Excel export writes the current grid state to a real .xlsx workbook, not a renamed CSV, so column widths, header styling and frozen panes survive the round trip into Excel or Google Sheets. A developer reaches for it wherever a report needs to leave the browser as a file a finance or operations colleague can open, filter and pivot on their own machine, rather than a static screenshot or a print-to-PDF. Calling export.excel() on a Lattice Grid instance builds the workbook from whatever is currently visible: the active column order, current sort, and any grouping, so the file a user downloads matches what they were looking at, not a fixed server-side template. As a JavaScript data grid with no server round trip involved, the export runs entirely client-side with no dependency pulled in to construct the workbook, which keeps the download instant even on a dataset of several thousand rows and avoids sending grid data to a backend purely to format a spreadsheet. Frozen panes are carried across automatically wherever the grid itself has pinned columns or a pinned header row, so the exported sheet keeps row and column headers in view exactly as the on-screen grid does, without a separate freeze-pane step for the developer to configure by hand.

How do I export a data grid to a formatted Excel file?

Call export.excel() on the grid instance. Lattice Grid writes an .xlsx file reflecting the current column order, sort and grouping, with header styling and any pinned rows or columns carried over as frozen panes, so the downloaded workbook opens in Excel already formatted rather than as a plain data dump needing manual cleanup.